<?php

namespace PurchasingBundle\Repository;


use Psr\Log\LoggerInterface;
use PurchasingBundle\Entity\Optional;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use Utils\StaticUtil\LogUtils;

/**
 * OptionalRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class OptionalRepository extends SchemaEntityRepository {


    /** @var LoggerInterface $logger */
    private $logger;

    /**
     * OptionalRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, Optional::class);

        $this->logger = $logger;
    }

    /**
     * @return array|mixed
     */
    public function findAllActiveOptionals () {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('o')
            ->from('PurchasingBundle:Optional', 'o')
            ->where('o.isDisabled IS NULL OR o.isDisabled=0')
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all active optionals", $exception);
        }

        return $results;
    }

    /**
     * @param int $type
     * @return array|mixed
     */
    public function findActiveOptionalsByType ($type=Optional::TYPE_DIGITAL_FORMAT) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('o')
            ->from('PurchasingBundle:Optional', 'o')
            ->where('(o.isDisabled IS NULL OR o.isDisabled=0) AND o.type=:type')
            ->setParameter('type', $type)
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get active optionals by type: ".$type, $exception);
        }

        return $results;
    }


}
